<?php

  define("AJAXURL", "http://ajax.googleapis.com/ajax/services/search/web");
  define("MANDATORYARGS", "?v=1.0&rsz=large&filter=0&safe=off");
  
  class app_google {
    private $apikey;
    private $referer;
    
    private $searchquery;
    private $currentpage;
    private $startindex;
    private $nextpage;
    private $rawreturn;
    private $decodedreturn;
    
    function __construct() {
      global $cfg;
      
      if ($cfg["googleajaxapikey"] == "") {
        $this->apikey = "";
      } else {
        $this->apikey = "&key=".$cfg["googleajaxapikey"]; 
      }
      
      $this->referer = $cfg["webaddress"];
    }
    
    function search($varquery) {
      $this->currentpage = 0;
      $this->startindex = 0;
      $this->searchquery = $varquery;
      
      $this->_gwebsearch($this->searchquery, $this->startindex);

      return $this->decodedreturn["responseData"]["results"];
    }

    function getnextpage() {
      if (!$this->eof()) {
        $this->currentpage++;
        $this->startindex = $this->decodedreturn["responseData"]["cursor"]["pages"][$this->currentpage]["start"];
        
        $this->_gwebsearch($this->searchquery, $this->startindex);
        
        return $this->decodedreturn["responseData"]["results"];
      } else {
        return false; 
      }
    }
    
    function getcurrentresults() {
      return $this->decodedreturn["responseData"]["results"]; 
    }
    
    function eof() {
      return !isset($this->decodedreturn["responseData"]["cursor"]["pages"][($this->currentpage+1)]);
    }
    
    private function _gwebsearch($varquery, $varstartindex) {
      $url = AJAXURL.MANDATORYARGS."&q=".urlencode($varquery)."&start=".$varstartindex;
      
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $url);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_REFERER, $this->referer);

      $this->rawreturn = curl_exec($ch);
      curl_close($ch);
      
      $this->decodedreturn = json_decode($this->rawreturn, true);
    }

    static function getrank($varsearch, $vardomain, $vardisplaydebug = false) {
      $search = new app_google();

      if ($vardisplaydebug) {
        echo "Performing Search: $varsearch...<br />"; 
        echo "For Domain: $vardomain...<br />";
      }

      $search->search($varsearch);
      $rank = -1;
      
      $pagenum = 0;
      do {
        if ($pagenum == 0) {
          $results = $search->getcurrentresults();
        } else {
          if ($vardisplaydebug) {
            echo "Sleeping...<br />";
          }
          
          sleep(1);
          
          if ($vardisplaydebug) {
            echo "Retreiving Page: $pagenum...<br />";
          }
          
          $results = $search->getnextpage();
        }
        
        for ($i = 0; $i < count($results); $i++) {
          if (strpos($results[$i]["visibleUrl"], $vardomain) !== false) {
            $rank = ($pagenum * 8) + ($i + 1);
            
            if ($vardisplaydebug) {
              echo "Found result on Page: $pagenum at Position: $i...<br />";
            }
            
            break 2; 
          }
        }   
        
        $pagenum++;    
      } while (!$search->eof());
      
      if ($vardisplaydebug) {
        echo "Returning Rank of $rank...<br />";  
      }
            
      return $rank;    
    }
    
  }
?>
