<?php
  /**
  * Sdk DB Configuration
  * 
  * @author Jon Smith <smithj@shedit.net.au>
  * @package js_sdk
  * @version 1.0
  */

  /**
  * Sdk DB Configuration
  */
  class sdk_db_conf extends sdk {
    private $dbhost;
    private $dbuser;
    private $dbpass;
    private $dbname;

    /**
    * Contructor
    * 
    * @param string $dbhost Hostname of DB Server
    * @param string $dbuser Username to connect to DB Server
    * @param string $dbpass Password to connect to DB Server
    * @param string $dbname Name of the Database to load
    * @return sdk_db_conf
    */
    function __construct($dbhost, $dbuser, $dbpass, $dbname) {
      $this->dbhost = $dbhost;
      $this->dbuser = $dbuser;
      $this->dbpass = $dbpass;
      $this->dbname = $dbname;
    }

    /**
    * Returns the Hostname of the DB
    * 
    * @return string Hostname of DB
    */
    function get_host() {
      return $this->dbhost;
    }

    /**
    * Returns the Username of the DB
    * 
    * @return string Username of DB
    */
    function get_user() {
      return $this->dbuser;
    }

    /**
    * Returns the Password of the DB
    * 
    * @return string Password of DB
    */
    function get_pass() {
      return $this->dbpass;
    }

    /**
    * Returns the name of the Database for the DB
    * 
    * @return string Database name for DB
    */
    function get_name() {
      return $this->dbname;
    }
      
  }
  
?>
