<?php
  /**
  * Sdk DB MySQL Implementation
  * 
  * @author Jon Smith <smithj@shedit.net.au>
  * @package js_sdk
  * @version 1.0
  */

  /**
  * Implementation of Abstract class Sdk DB - MySQL
  * 
  * @package js_sdk
  */
  class sdk_db_mysql extends sdk_db {

    /**
    * Constructor, opens connection to database
    *     
    * @param sdk_db_conf $dbinfo Config object, if not passed sdk_db will look for global variable
    * @return sdk_db_mysql
    */
    function __construct(sdk_db_conf $dbinfo = null) {
      parent::__construct($dbinfo);
      
      $this->dblink = mysql_pconnect($this->dbinfo->get_host(), $this->dbinfo->get_user(), $this->dbinfo->get_pass());
      
      if (!$this->dblink) {
        throw new sdk_exception_mysql("Could not connect: ".mysql_error());
      }
      
      $selected_db = mysql_select_db($this->dbinfo->get_name());
      
      if (!$selected_db) {
        throw new sdk_exception_mysql("Not connected: ".mysql_error()); 
      }
      $this->currentsql = "";
         
    }

    /**
    * Query to execute (Usually a SELECT statement)
    * 
    * @param string $sql SQL Statement
    */
    function query($sql) {
      $this->rs = mysql_query($sql, $this->dblink);
      
      if (!$this->rs) {
        throw new sdk_exception_mysql(mysql_error($this->dblink)); 
      }
      
      $this->row = mysql_fetch_array($this->rs, MYSQL_BOTH);
      $this->currentsql = $sql;
    }    

    /**
    * Returns the number of rows in a recordset
    * 
    * @return int
    */
    function getNumRows() {
      return mysql_num_rows($this->rs);  
    }
    
    /**
    * Move to the next row in the recordset
    */
    function moveNext() {
      $this->row = mysql_fetch_array($this->rs, MYSQL_BOTH);
      return $this->row;
    }

    /**
    * Move to the first row in the recordset
    */
    function moveFirst() {
      if (mysql_num_rows($this->rs) != 0) {
        mysql_data_seek($this->rs, 0);
      }
      $this->row = mysql_fetch_array($this->rs, MYSQL_BOTH);
    }
    
    /**
    * Close query connection 
    */
    function closequery() {
      mysql_free_result($this->rs);
      $this->currentsql = "";
    }

    /**
    * Run once off SQL commands (Usually INSERT, UPDATE or DELETE)
    * 
    * @param string $runsql SQL Statement to run
    * @return int If SQL was an insert will return the ID of the newly created record
    */
    function runsql($runsql) {
      $result = mysql_query($runsql, $this->dblink);
      
      if (!$result) {
        throw new sdk_exception_mysql(mysql_error($this->dblink)); 
      }
      
      return mysql_insert_id($this->dblink);
    }

    /**
    * Retreives the ID of the newly created DB record 
    * 
    * @return int Returns the ID of a newly created record
    */
    function getInsertID() {
      $result = mysql_insert_id();
      return $result;
    }

    /**
    * Returns the number of rows affected by the SQL
    * 
    * @return int Returns the number of rows affected by the SQL
    */
    function getRowsAffected() {
      $result = mysql_affected_rows();
      return $result;
    }
    
    /**
    * Make a string safe for use with the Database
    * 
    * @param string $string String to escape
    * @return string Escaped string
    */
    function escape_string($string) {
      return mysql_real_escape_string($string, $this->dblink); 
    }

    /**
    * Deletes a DB Parameter from the tbl_parms table
    * 
    * @param string $parmname Name of the Parameter
    * @return string Returns status of operation
    */
    function deleteParm($parmname) {
      if ($parmname <> "") {
        $ParmSQL = "DELETE FROM tbl_parms WHERE name = '".$parmname."';";

        $result = mysql_query($ParmSQL, $this->dblink);
        if (!$result) {
          throw new sdk_exception_mysql(mysql_error($this->dblink)); 
        }

        return "ok";
      } else {
        return "error";
      }
    }

    /**
    * Returns a DB Parameter from the tbl_parms table
    * 
    * @param string $parmname Name of the Parameter
    * @return string Returns the value of the Parameter
    */
    function getParm($parmname) {
      if ($parmname <> "") {
        $ParmSQL = "SELECT `value` FROM tbl_parms WHERE name = '".$parmname."'";

        $result = mysql_query($ParmSQL, $this->dblink);
      
        if (!$result) {
          throw new sdk_exception_mysql(mysql_error($this->dblink)); 
        }  
      
        if ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
          return $row['value'];
        } else {
          return "novalue";
        }
      } else {
        return "error";
      }
    }

    /**
    * Creates a new DB Parameter in the tbl_parms table
    * 
    * @param string $parmname Name of the Parameter
    * @param mixed $parmvalue Value of the Patameter
    * @return string Returns the status of the operation
    */
    function setParm($parmname, $parmvalue) {
      if ($parmname <> "" && $parmvalue <> "") {
        $ParmSQL = "SELECT * FROM tbl_parms WHERE name = '".$parmname."';";
        $result = mysql_query($ParmSQL, $this->dblink);
        
        if (!$result) {
          throw new sdk_exception_mysql(mysql_error($this->dblink)); 
        }
      
        if ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
          mysql_free_result($result);
          $ParmSQL = "UPDATE tbl_parms SET `value` = '".$parmvalue."' WHERE name = '".$parmname."';";
          $result = mysql_query($ParmSQL, $this->dblink);
          if (!$result) {
            throw new sdk_exception_mysql(mysql_error($this->dblink)); 
          }
        
          return "ok";
        } else {
          mysql_free_result($result);
          $ParmSQL = "INSERT INTO tbl_parms (name, `value`) VALUES ('".$parmname."', '".$parmvalue."');";
          $result = mysql_query($ParmSQL, $this->dblink);
          
          if (!$result) {
            throw new sdk_exception_mysql(mysql_error($this->dblink)); 
          }
        
          return "ok";
        }
      } else {
        return "error";
      }
    }

    /**
    * Display table outputs to the Browser a visual representation of the recordset 
    */
    function displayTable() {
      $this->moveFirst();
      $numFields = mysql_num_fields($this->rs);
      echo "\n";
      echo "<table border='1'>\n";
      echo "  <tr>\n";
      for ($i = 0; $i < $numFields; $i++) {
        echo "    <th>".mysql_field_name($this->rs, $i)."</th>\n";
      }
      echo "  </tr>\n";
      while (!$this->eof()) {
        $row = $this->getRow(true);
        echo "  <tr>\n";
        for ($i = 0; $i < $numFields; $i++) {
          if ($row[$i] == "") {
            echo "    <td>&nbsp;</td>\n";
          } else {
            echo "    <td>".$row[$i]."</td>\n";
          }
        }
        echo "  </tr>\n";
        $this->moveNext();
      }
      echo "</table>\n";
      $this->moveFirst();
    }

  } // end sdk_db_mysql
  
?>