<?php
  include_once("_lib/sdk/autoload.php");

  app_site::header();
  app_site::needauth();
  
  $page = app_site::getpage();
  
  $page->before();

  $sitedb = new sdk_db_mysql();
  $kwdb = new sdk_db_mysql();
  $resdb = new sdk_db_mysql();
  
  $sql = "SELECT `id`, `domain` FROM `tbl_site` ORDER BY `domain`;";
  $sitedb->query($sql);
  
  switch ($action) {
    case "":
?>
<div id="displaytable">
<table cellspacing="0" cellpadding="5" border="0" class="display">
  <tr class="headerrow">
    <th align="left">&nbsp;</th>
    <th align="left" class="borderright">Keyword</th>
    <th align="left" colspan="2">Result</th>
  </tr>
<?php
  if ($sitedb->eof()) {
?>
  <tr>
    <td colspan="4">There are no sites registered</td>
  </tr>
<?php 
  }
  
  while (!$sitedb->eof()) {
    $siterow = $sitedb->getRow();

    $sql = "SELECT * FROM `tbl_keywordsearch` WHERE `siteid` = %d ORDER BY `keyword`;";
    $sql = sprintf($sql, $siterow["id"]);
    $kwdb->query($sql);
?>
  <tr class="domainrow">
    <td colspan="4"><b><?php echo $siterow["domain"]; ?></b><span class="littletext"> &middot; <a href="admin.php?action=newkeyword&siteid=<?php echo $siterow["id"]; ?>">Add new keyword</a>
    <?php
      if ($kwdb->eof()) {
    ?>
    &middot; <a href="admin.php?action=sitedelete&siteid=<?php echo $siterow["id"]; ?>" onclick="return confirm('Are you sure you want to delete this site?');">Delete</a>
    <?php 
      }
    ?>
    </span></td>
  </tr>
<?php
    
    if ($kwdb->eof()) {
?>
  <tr>
    <td>&nbsp;</td>
    <td colspan="3">No Keywords Registered</td>
  </tr>
<?php
    }    

    while (!$kwdb->eof()) {
      $kwrow = $kwdb->getRow();
      
      $sql = "SELECT * FROM `tbl_keywordresult` WHERE `keywordid` = %d ORDER BY id DESC;";
      $sql = sprintf($sql, $kwrow["id"]);
      $resdb->query($sql);
      
      if ($resdb->eof()) {
        $rank = "No Results"; 
      } else {
        $resrow = $resdb->getRow();
        if ($resrow["rank"] == -1) {
          $rank = "Not in Top 64"; 
        } else {
          $rank= $resrow["rank"];
        }
      }
      
      $resdb->closequery();
?>
  <tr>
    <td>&nbsp;</td>
    <td><?php echo urldecode($kwrow["keyword"]); ?></td>
    <td><?php echo $rank; ?></td>
    <td><span class="littletext"><a href="admin.php?action=keyworddelete&keywordid=<?php echo $kwrow["id"]; ?>" onclick="return confirm('Are you sure you want to delete this keyword?');">Delete</a> &middot;
      <a href="index.php?action=history&keywordid=<?php echo $kwrow["id"]; ?>">View History</a></span></td>
  </tr>
<?php
      $kwdb->moveNext(); 
    }
    $kwdb->closequery();
    
    $sitedb->moveNext();  
  }
?>
</table>
<span class="littletext"><a href="admin.php?action=addsite">Add New Site</a></span>
</div>
<?php    
      $sitedb->closequery();
      
      break;
    case "history":
      $kwid = $_REQUEST["keywordid"];
      
      $db = new sdk_db_mysql();
      $sql = "SELECT `domain`, `keyword` FROM `tbl_site`, `tbl_keywordsearch` ";
      $sql .= "WHERE `tbl_site`.`id` = `tbl_keywordsearch`.`siteid` ";
      $sql .= "AND `tbl_keywordsearch`.`id` = %d;";
      $sql = sprintf($sql, $kwid);
      $db->query($sql);
      
      if ($db->eof()) {
        $db->closequery();
        die("Page entered in error"); 
      } else {
        $row = $db->getRow();
        $db->closequery();
        
        $site = $row["domain"];
        $keyword = $row["keyword"];
        
        $sql = "SELECT * FROM `tbl_keywordresult` ";
        $sql .= "WHERE `keywordid` = %d ";
        $sql .= "ORDER BY `id` DESC;";
        $sql = sprintf($sql, $kwid);
        $db->query($sql); 
      }
?>
<div id="displaytable">
<table cellspacing="0" cellpadding="5" border="0" class="display">
  <tr class="headerrow">
    <th align="left">Site</th>
    <th align="left">Keyword</th>
  </tr>
  <tr class="domainrow">
    <td><?php echo $site; ?></td>
    <td><?php echo $keyword; ?></td>
  </tr>
<?php
  if ($db->eof()) {
    echo "There are no results for this keyword"; 
  } else {
?>
  <tr>
    <th>Rank</th>
    <th>Date</th>
  </tr>
<?php
    while (!$db->eof()) {
      $row = $db->getRow(true);
?>
  <tr>
    <td align="center"><?php 
      if ($row["rank"] == -1) {
        echo "Not in the Top 64"; 
      } else {
        echo $row["rank"]; 
      }
    ?></td>
    <td align="center"><?php echo date(DATEFORMAT, strtotime($row["timestamp"])); ?></td>
  </tr>
<?php
      $db->moveNext();
    }
?>
<?php
  }
?>
</table>
</div>
<?php    
      break;
  }
?>
<?php  
  $page->after();
?>